<template>
  <div class="grid lg:grid-cols-4 md:grid-cols-2 sm:grid-cols-1 gap-3 pb-5">
    <stat-box
      title="New Users"
      value="4,232"
      icon="fa-user"
      footer="Updated Now"
    />

    <stat-box
      title="Active Users"
      value="169"
      icon="fa-user-secret"
      footer="Updated 20 minutes ago"
    />

    <stat-box
      title="Total Users"
      value="25,203"
      icon="fa-users"
      footer="Updated Now"
    />

    <stat-box
      title="Referrals"
      value="123"
      :iconOutline="true"
      icon="fa-share-square"
      footer="Updated Now"
      boxColor="white"
      iconColor="black"
    />
  </div>

  <div class="grid lg:grid-cols-6 md:grid-cols-4 sm:grid-cols-1 gap-3">
    <box class="lg:col-span-4 md:col-span-3">
      <template v-slot:title>Monthly Traffic</template>

      <div class="px-3">Fancy graph here.</div>
    </box>

    <box class="lg:col-span-2 md:col-span-1">
      <template v-slot:title>Recent Activity</template>
      <ul class="px-3">
        <li
          class="flex flex-row py-3"
          v-for="(activity, i) in tempRecentActivity"
          :key="i"
        >
          <recent-activity
            :title="activity.title"
            :icon="activity.icon"
            :iconColor="activity.iconColor"
            :message="activity.message"
          />
        </li>
      </ul>
    </box>
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import StatBoxVue from './components/StatBox.vue';
import RecentActivityVue from './components/RecentActivity.vue';

interface RecentActivity {
  title: string;
  message: string;
  icon: string;
  iconColor?: string;
}

export default defineComponent({
  name: 'dashboard',
  components: {
    'stat-box': StatBoxVue,
    'recent-activity': RecentActivityVue,
  },
  setup() {
    const tempRecentActivity: RecentActivity[] = [
      {
        title: 'New User!',
        message: 'Johnny John just signed up as a premium user!',
        icon: 'fa-user',
      },
      {
        title: 'New Referall!',
        message: 'Johnny John reffered a new user: Luke Skywalker!',
        icon: 'fa-share-square',
        iconColor: '#528fa8',
      },
      {
        title: 'New User!',
        message: 'Luke Skywalker just signed up as a premium user!',
        icon: 'fa-user',
      },
    ];

    return { tempRecentActivity };
  },
});
</script>